/**************************************************
 Jay Kang
 3D Visualization
 Algorithmic Visualization - Winter 2012
 UCSB MAT 259
 **************************************************/

import processing.opengl.*;
import javax.media.opengl.*;
import peasy.*;
import peasy.org.apache.commons.math.*;
import controlP5.*;
import codeanticode.glgraphics.*;
import de.bezier.data.sql.*;

// global variables
MySQL msql; // MySQL
String filename = "2012d.csv";
int startYear    = 2009;
int endYear      = 2012;
int tStart;
int numMonth;
color[] palette;

// spacing variables
int topBorder = 100;
int leftBorder = 30;

// switches
boolean enableGrid = true;
boolean enableGUI = true;
boolean lockGUI = true;
boolean enablePyramid = false;
boolean enableDewey = false;
boolean enableStroke = false;
boolean enableStat = false;

int keyIndex = 0;

// data containers
String[] keywords = {
  "facebook", "twitter", "linkedin"
};
String[] legends = {
  "000: Computer Science", "100: Philosophy", "200: Religion", "300: Social Science", "400: Language", "500: Science", "600: Technology & Applied Science", "700: Arts & Recreation", "800: Literature", "900: History & Geography"
};
String[] controls = {
  "-CONTROLS-", "[1-4] Camera Modes", "[c/x] change colors", "[l] stroke on/off", "[s] stat on/off", "[d] dewey particles", "[p] pyramids"
};

ArrayList<ArrayList> mArray = new ArrayList<ArrayList>();
ArrayList<ArrayList> dArray = new ArrayList<ArrayList>();
ArrayList            cArray;

HashMap hmap;
HashMap hmapMonth;
HashMap hmapDewey;
int[] totalCount = {
  0, 0, 0
};
int[] annualCount = new int[endYear - startYear + 1];
int[] monthlyCount = new int[72];
String[] wd = {
  "", "", "", "", "", "", "", "", "", ""
};

// fonts
PFont font0, font1, font2, font3;

//ControlP5
//ControlP5 cp5;
//CheckBox checkbox;
//color c = color(0, 160, 100);

// PeasyCam
PeasyCam cam;
boolean displayHUD = true;
boolean rotateCam = false; // from RJ's project
float xRot = 0;
float yRot = 0;
float zRot = 0;
float[] rotations = new float[3];  // for billboarding
float[] peasyCamPosition;

//PGraphics
PGraphics offScreen;



void setup() {

  // data read
  readData();

  //  size(800, 600, P3D);
  size(screen.width, screen.height, GLConstants.GLGRAPHICS);
  //  size(10,10);
  hint(DISABLE_OPENGL_2X_SMOOTH);
  hint(ENABLE_OPENGL_4X_SMOOTH);
  background(#CCCCCC);
  smooth();
  colorMode(HSB, 360, 100, 100, 100);
  frameRate(60);

  //  offScreen = createGraphics(500,200, P2D);

  cam = new PeasyCam(this, 0, 0, 0, 2400);
  //  cam = new PeasyCam(this, 0);
  cam.setMinimumDistance(300);
  cam.setMaximumDistance(5000);

  // camera control modes
  cam.setRollRotationMode();

  // load fonts
//  font0 = loadFont("AcknowledgeTTBRK-36.vlw");
  font0 = loadFont("Manteka-40.vlw");
  font1 = loadFont("Manteka-16.vlw");
  font2 = loadFont("Manteka-180.vlw");
  font3 = loadFont("Helvetica-20.vlw");
  // textFont(font0, 36);
  textFont(font1, 40);
  
  
  cArray = new ArrayList();

  loadColors();
  // g3 = (PGraphics3D)g;

  // animation
  tStart = millis();
}

